/**
 * Created by zhouhuan on 2017/11/2.
 */
import React from 'react';
import { View, ScrollView } from 'react-native';
import { List, InputItem, WhiteSpace, WingBlank } from 'antd-mobile';
import { connect } from 'react-redux';
import Icon from 'react-native-vector-icons/FontAwesome';
import { createAction } from '../../../utils';

@connect(({ peopleInfo }) => ({ peopleInfo }))
class PeopleDetailInfo extends React.Component {
  componentDidMount() {
    const { id } = this.props.navigation.state.params;
    this.props.dispatch(createAction('peopleInfo/getPeopleDetail')(id));
  }
  onEdit =() => {
    this.props.dispatch(createAction('peopleInfo/GoToPeopleDetailEditScreen')());
  };
  render() {
    const { detailData, editable, metas } = this.props.peopleInfo;
    if (editable === true) {
      return (
        <ScrollView>
          <WhiteSpace/>
          <View style={{flexDirection: 'row', justifyContent: 'space-between'}}>
            <Icon.Button
              name="id-card"
              backgroundColor="#08BBF9"
              onPress={() => {
                this.props.dispatch({type: 'peopleInfo/DuKa'});
              }}
            >
              读卡
            </Icon.Button>
          </View>
          <WhiteSpace/>
          <List>
            {
              metas.map((m) => {
                if (m.required === true) {
                  return (
                    <InputItem
                      {...getFieldProps(m.key, {
                        initialValue: detailData[m.key],
                        rules: [
                          {required: true, message: '不允许为空'},
                          {validator: this.validateNoNull},
                        ],
                      })}
                      clear
                      placeholder="请输入"
                      ref={(el) => {
                        this.customFocusInst = el;
                      }}
                    >
                      {m.label}
                    </InputItem>
                  );
                } else {
                  return (
                    <InputItem
                      {...getFieldProps(m.key, {
                        initialValue: detailData[m.key],
                      })}
                      clear
                      placeholder="请输入"
                      ref={(el) => {
                        this.customFocusInst = el;
                      }}
                    >
                      {m.label}
                    </InputItem>
                  );
                }
              })}
            {[1].map(() => {
              return (
                <List.Item>
                  <View style={{flexDirection: 'row', justifyContent: 'center'}}>
                    <Icon.Button
                      name="save"
                      backgroundColor="#08BBF9"
                      onPress={this.onSubmit}
                    >
                      保存
                    </Icon.Button>
                  </View>
                </List.Item>
              );
            })
            }
          </List>
        </ScrollView>
      );
    } else {
      return (
        <ScrollView>
          <WhiteSpace />
          <WhiteSpace />
          <WingBlank>
            <View style={{ flexDirection: 'row', justifyContent: 'space-between' }}>
              <Icon.Button
                name="edit"
                backgroundColor="#08BBF9"
                onPress={this.onEdit}
              >
                编辑
              </Icon.Button>
            </View>
            <WhiteSpace />
            <List>
              {
                metas.map((m) => {
                  return (
                    <List.Item
                      key={m.key}
                      extra={detailData[m.key]}
                    >
                      {m.label}
                    </List.Item>
                  );
                })
              }
            </List>
          </WingBlank>
        </ScrollView>
      );
    }
  }
}
export default PeopleDetailInfo;
